import { Component, OnInit } from "@angular/core";
import { ActivatedRoute } from "@angular/router";
import { Location } from "@angular/common";
import { CouchbaseInstance } from "../../couchbase";
import { ForgeInstance } from "../../forge";

@Component({
    selector: "create",
    templateUrl: "./components/create/create.component.html",
    styleUrls: ["./components/create/create.component.css"]
})
export class CreateComponent implements OnInit {

    private database: any;
    private masterPassword: string;
    public title: string;
    public username: string;
    public password: string;

    public constructor(private location: Location, private route: ActivatedRoute, private forgeInstance: ForgeInstance, private couchbaseInstance: CouchbaseInstance) {
        this.database = this.couchbaseInstance.getDatabase();
        this.masterPassword = "";
        this.title = "";
        this.username = "";
        this.password = "";
    }

    public ngOnInit() {
        this.route.params.subscribe((params) => {
            this.masterPassword = params["password"];
        });
    }

    public save() {
        if(this.title && this.username && this.password) {
            this.database.createDocument({
                "title": this.title,
                "username": this.forgeInstance.encrypt(this.username, this.masterPassword),
                "password": this.forgeInstance.encrypt(this.password, this.masterPassword)
            });
            this.location.back();
        }
    }

}