import { Component, OnInit } from "@angular/core";
import { Router, ActivatedRoute } from "@angular/router";
import { Location } from "@angular/common";
import { CouchbaseInstance } from "../../couchbase";

@Component({
    selector: "list",
    templateUrl: "./components/list/list.component.html",
    styleUrls: ["./components/list/list.component.css"]
})
export class ListComponent implements OnInit {

    private database: any;
    private masterPassword: string;
    public passwordList: Array<Object>;

    public constructor(private router: Router, private location: Location, private route: ActivatedRoute, private couchbaseInstance: CouchbaseInstance) {
        this.masterPassword = "";
        this.passwordList = [];
        this.database = this.couchbaseInstance.getDatabase();
    }

    public ngOnInit() {
        this.route.params.subscribe((params) => {
            this.masterPassword = params["password"];
        });
        this.location.subscribe((path) => {
            this.load();
        });
        this.load();
    }

    private load() {
        let rows = this.database.executeQuery("passwords", {descending: false});
        this.passwordList = rows;
    }

    public viewDetails(item: any) {
        this.router.navigate(["view", this.masterPassword, item._id]);
    }

    public create() {
        this.router.navigate(["create", this.masterPassword]);
    }

}