import { Component, OnInit } from "@angular/core";
import { Router } from "@angular/router";
import { Location } from "@angular/common";
import { CouchbaseInstance } from "../../couchbase";
import { BcryptInstance } from "../../bcrypt";

@Component({
    selector: "login",
    templateUrl: "./components/login/login.component.html",
    styleUrls: ["./components/login/login.component.css"]
})
export class LoginComponent implements OnInit {

    private database: any;
    public password: string;

    public constructor(private router: Router, private location: Location, private couchbaseInstance: CouchbaseInstance, private bcrypt: BcryptInstance) {
        this.database = this.couchbaseInstance.getDatabase();
        this.password = "";
    }

    public ngOnInit() {
        this.location.subscribe((path) => {
            this.password = "";
        });
    }

    public validate() {
        if(this.password) {
            let masterPassword = this.database.getDocument("master-password");
            if(masterPassword) {
                if(this.bcrypt.compare(this.password, masterPassword.password)) {
                    this.router.navigate(["list", this.password]);
                }
            }
        }
    }

    public reset() {
        this.router.navigate(["reset"]);
    }

}