import { Component } from "@angular/core";
import { Location } from "@angular/common";
import { Router } from "@angular/router";
import { CouchbaseInstance } from "../../couchbase";
import { BcryptInstance } from "../../bcrypt";

@Component({
    selector: "reset",
    templateUrl: "./components/reset/reset.component.html",
    styleUrls: ["./components/reset/reset.component.css"]
})
export class ResetComponent {

    private database: any;
    public password: string;
    public confirmation: string;

    public constructor(private location: Location, private couchbaseInstance: CouchbaseInstance, private bcrypt: BcryptInstance) {
        this.database = this.couchbaseInstance.getDatabase();
        this.password = "";
        this.confirmation = "";
    }

    public reset() {
        if(this.password && this.confirmation) {
            if(this.password == this.confirmation) {
                let rows = this.database.executeQuery("passwords");
                for(let i = 0; i < rows.length; i++) {
                    this.database.deleteDocument(rows[i]._id);
                }
                this.database.deleteDocument("master-password");
                this.database.createDocument({
                    "password": this.bcrypt.create(this.password)
                }, "master-password");
                this.location.back();
            }
        }
    }

}