import { Component, OnInit } from "@angular/core";
import { Router, ActivatedRoute } from "@angular/router";
import { CouchbaseInstance } from "../../couchbase";
import { ForgeInstance } from "../../forge";

@Component({
    selector: "view",
    templateUrl: "./components/view/view.component.html",
    styleUrls: ["./components/view/view.component.css"]
})
export class ViewComponent implements OnInit {

    private database: any;
    public passwordItem: any;

    public constructor(private router: Router, private route: ActivatedRoute, private couchbaseInstance: CouchbaseInstance, private forgeInstance: ForgeInstance) {
        this.passwordItem = {};
        this.database = this.couchbaseInstance.getDatabase();
    }

    public ngOnInit() {
        this.route.params.subscribe((params) => {
            this.passwordItem = this.database.getDocument(params["id"]);
            this.passwordItem.username = this.forgeInstance.decrypt(this.passwordItem.username.cipherText, params["password"], this.passwordItem.username.salt, this.passwordItem.username.iv);
            this.passwordItem.password = this.forgeInstance.decrypt(this.passwordItem.password.cipherText, params["password"], this.passwordItem.password.salt, this.passwordItem.password.iv);
        });
    }

}