var forge = require("node-forge");

export class ForgeInstance {

    public constructor() { }

    public encrypt(message: string, password: string) {
        let salt = forge.random.getBytesSync(128);
        let key = forge.pkcs5.pbkdf2(password, salt, 4, 16);
        let iv = forge.random.getBytesSync(16);
        let cipher = forge.cipher.createCipher('AES-CBC', key);
        cipher.start({iv: iv});
        cipher.update(forge.util.createBuffer(message));
        cipher.finish();
        return {
            cipherText: forge.util.encode64(cipher.output.getBytes()),
            salt: forge.util.encode64(salt),
            iv: forge.util.encode64(iv)
        };
    }

    public decrypt(cipherText: string, password: string, salt: string, iv: string) {
        let key = forge.pkcs5.pbkdf2(password, forge.util.decode64(salt), 4, 16);
        let decipher = forge.cipher.createDecipher('AES-CBC', key);
        decipher.start({iv: forge.util.decode64(iv)});
        decipher.update(forge.util.createBuffer(forge.util.decode64(cipherText)));
        decipher.finish();
        return decipher.output.toString();
    }

}